/*
    Fichier groupeligne.c
    Auteur Bernard Chardonneau

    Logiciel libre, droits d'utilisation prciss en franais
    dans le fichier : licence-fr.txt

    Traductions des droits d'utilisation dans les fichiers :
    licence-de.txt , licence-en.txt , licence-es.txt ,
    licence-it.txt , licence-nl.txt , licence-pt.txt ,
    licence-eo.txt , licence-eo-utf.txt

    Droits d'utilisation galement sur la page web :
    http://libremail.tuxfamily.org/voir.php?page=droits


    Fonctions permettant de regrouper 2 lignes conscutives
    dans le source d'un mail lorsque le passage  la ligne
    doit tre supprim  l'affichage.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "buflect.h"
#include "fmail.h"
#include "encodage.h"
#include "trtligne.h"
#include "groupeligne.h"


/* prototype */
void genligne (char *buffer);



/* Ajuste la taille en octets du paramtre buffer
    la chaine de caractres qu'il contient
*/

char *ajustebuf (char *buffer)
{
    char *nouvbuf;


    // essayer de crer un nouveau buffer de la bonne taille
    nouvbuf = (char *) malloc (strlen (buffer) + 1);

    // si cration russie
    if (nouvbuf)
    {
        // recopier l'ancien buffer dans le nouveau
        strcpy (nouvbuf, buffer);

        // on peut librer l'espace mmoire occup par l'ancien buffer
        free (buffer);

        // et retourner l'adresse du nouveau
        return (nouvbuf);
    }
    // sinon
    else
        // mauvais signe : on garde l'adresse de l'ancien buffer
        return (buffer);
}



/* Regroupement de la ligne de texte passe
   en paramtre avec la ligne suivante du mail
*/

void regroupeligne (char *buffer)
{
    char *lignefusion;
    char carsuiv;
    int  i, j;


    // allouer un buffer pour contenir les 2 lignes
    lignefusion = (char *) malloc (strlen (buffer) + sizeof (buf_lect) + 1);

    // si espace mmoire suffisant
    if (lignefusion)
    {
        // recopier la dernire ligne lue dans ce buffer
        strcpy (lignefusion, buffer);

        // lire et convertir la suivante et la recopier  la suite
        if (lire_fmail ())
        {
            majligne ();
            strcat (lignefusion, buf_lect);

            // on cherche  optimiser la mmoire utilise
            lignefusion = ajustebuf (lignefusion);

            // si encodage base 64
            if (encodage_texte == Base64)
            {
                // on va gnrer les lignes compltes mmorises
                // non indispensable, mais a limite la consommation mmoire
                do
                {
                    i = 0;
                    j = 0;

                    // chercher si passage  la ligne dans le texte mmoris
                    while (lignefusion [i] != '\n' && lignefusion [i])
                        i++;

                    // si passage  la ligne trouv
                    if (lignefusion [i] == '\n')
                    {
                        // terminer la chaine aprs ce passage  la ligne
                        carsuiv = lignefusion [i + 1];
                        lignefusion [i + 1] = '\0';

                        // gnrer la ligne correspondante
                        genligne (lignefusion);

                        // restaurer le premier caractre de la ligne suivante
                        lignefusion [i + 1] = carsuiv;

                        // et supprimer la ligne traite du buffer
                        do
                            lignefusion [j++] = lignefusion [++i];
                        while (lignefusion [i]);
                    }
                }
                // on recommence tant qu'on a pu gnrer une ligne complte
                while (j > 0);
            }

            // s'il reste un dbut de ligne
            if (*lignefusion)
            {
                // le prendre en compte de la manire la plus adquate
                if (lignefusion [strlen (lignefusion) - 1] != '\n')
                {
                    // un nouvel appel de regroupeligne va avoir lieu
                    // on cherche  optimiser la mmoire utilise
                    lignefusion = ajustebuf (lignefusion);

                    // on peut regrouper les lignes
                    regroupeligne (lignefusion);
                }
                else
                    // cas d'un \n en fin de chaine, on gnre la ligne
                    genligne (lignefusion);
            }

            // librer le buffer de travail
            free (lignefusion);
        }
        // sinon, (manque de mmoire) on va juste gnrer la ligne
        else
            genligne (buffer);
    }
    // sinon, (fin de mail) on va juste gnrer la ligne passe en paramtre
    else
        genligne (buffer);
}
