/*
    Fichier vsourcemail.c
    Auteur Bernard Chardonneau

    Logiciel libre, droits d'utilisation prciss en franais
    dans le fichier : licence-fr.txt

    Traductions des droits d'utilisation dans les fichiers :
    licence-de.txt , licence-en.txt , licence-es.txt ,
    licence-it.txt , licence-nl.txt , licence-pt.txt ,
    licence-eo.txt , licence-eo-utf.txt

    Droits d'utilisation galement sur la page web :
    http://libremail.tuxfamily.org/voir.php?page=droits


    Ce programme affiche un mail en attente de tlchargement
    (ou de destruction).
    Un fichier de configuration est utilis pour se connecter  la
    boite aux lettres.
    Le mail  afficher est repr par son numro d'ordre dans la
    liste des mails sur le serveur.
*/

#define appli   // pour la dclaration de variables globales  l'application

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "messages.h"
#include "buflect.h"
#include "ficonf.h"
#include "pop.h"


/* prototype */
void affsource (int numes);


/* programme principal */

int main (int nbarg, char *varg[])
{
    FILE *fconf;        // descripteur du fichier de configuration
    int  numes;         // numro du mail courant


    // rcupration du nom de l'excutable
    memcom (*varg);

    // controle du nombre d'arguments
    if (--nbarg == 2)
    {
        // ouvrir le fichier de configuration
        fconf = ouvre_ficonf (varg [2]);

        if (fconf)
        {
            // connexion sur le compte mail du serveur pop
            if (connect_pop (fconf))
            {
                // rcuprer le numro de mail
                numes = atoi (varg [1]);

                // afficher ce mail si possible
                if (numes > 0 && numes <= nbmails ())
                    affsource (numes);
                else if (numes > 0)
                    // "Numro de mail trop grand"
                    affiche_err ("NUMAIL_TROP_GRAND");
                else
                    // "Numro de mail %s incorrect"
                    aff_err_arg ("NUMAIL_FAUX", varg [1]);

                // se dconnecter proprement du serveur pop
                deconnect_pop ();
            }

            // on n'a plus besoin du fichier de configuration
            fclose (fconf);
        }
    }
    else
        // "Syntaxe : %s [-(h|H)] numro_message fichier_configuration"
        psyntaxe ("SYNT_VSOURCEMAIL");

    // pour faire plaisir  gcc qui veut une fonction main de type int
    return (0);
}


/* lit le mail choisi et l'affiche sans traitement des lignes */

void affsource (int numes)
{
    char bufw [80]; // buffer d'envoi d'une requte

    // demande de lecture du message
    sprintf (bufw, "RETR %d", numes);
    env_pop (bufw);

    // "Message %d\n"
    printf (message ("AFF_NUMAIL"), numes);

    // lire une ligne de l'entte du message
    lire_pop ();

    // lecture et affichage du source du mail
    do
    {
        // affichage de la dernire ligne lue
        puts (buf_lect);

        // et lecture de la suivante
        lire_pop ();
    }
    // on s'arrte en fin de mail
    while (buf_lect [0] != '.' || buf_lect [1] != '\0');
}
